import errno
import logging
import os
import subprocess

logging.basicConfig(level=logging.INFO)
logger = logging.getLogger('utils')


class UserException(Exception):
    pass

def call(command, cwd=None):
    logger.debug('Call command "%s" inside path "%s"' % (
        command, cwd or '.'))
    process = subprocess.Popen(
        command, shell=True, cwd=cwd, stdout=subprocess.PIPE,
        stderr=subprocess.PIPE,
    )
    process.wait()
    if process.returncode != 0:
        logger.debug('Command "%s" failed inside path "%s"' % (
            command, cwd or '.'))
    return process


def mkdir(path):
    if os.path.exists(path) and os.path.isdir(path):
        return
    try:
        os.makedirs(path)
    except OSError as exc:
        if exc.errno != errno.EEXIST:
            raise
